/*!
 * clipboard.js v1.6.1
 * https://zenorocha.github.io/clipboard.js
 *
 * Licensed MIT © Zeno Rocha
 */
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,t.Clipboard=e()}}(function(){var e,t,n;return function e(t,n,o){function i(a,c){if(!n[a]){if(!t[a]){var l="function"==typeof require&&require;if(!c&&l)return l(a,!0);if(r)return r(a,!0);var u=new Error("Cannot find module '"+a+"'");throw u.code="MODULE_NOT_FOUND",u}var s=n[a]={exports:{}};t[a][0].call(s.exports,function(e){var n=t[a][1][e];return i(n?n:e)},s,s.exports,e,t,n,o)}return n[a].exports}for(var r="function"==typeof require&&require,a=0;a<o.length;a++)i(o[a]);return i}({1:[function(e,t,n){function o(e,t){for(;e&&e.nodeType!==i;){if(e.matches(t))return e;e=e.parentNode}}var i=9;if("undefined"!=typeof Element&&!Element.prototype.matches){var r=Element.prototype;r.matches=r.matchesSelector||r.mozMatchesSelector||r.msMatchesSelector||r.oMatchesSelector||r.webkitMatchesSelector}t.exports=o},{}],2:[function(e,t,n){function o(e,t,n,o,r){var a=i.apply(this,arguments);return e.addEventListener(n,a,r),{destroy:function(){e.removeEventListener(n,a,r)}}}function i(e,t,n,o){return function(n){n.delegateTarget=r(n.target,t),n.delegateTarget&&o.call(e,n)}}var r=e("./closest");t.exports=o},{"./closest":1}],3:[function(e,t,n){n.node=function(e){return void 0!==e&&e instanceof HTMLElement&&1===e.nodeType},n.nodeList=function(e){var t=Object.prototype.toString.call(e);return void 0!==e&&("[object NodeList]"===t||"[object HTMLCollection]"===t)&&"length"in e&&(0===e.length||n.node(e[0]))},n.string=function(e){return"string"==typeof e||e instanceof String},n.fn=function(e){var t=Object.prototype.toString.call(e);return"[object Function]"===t}},{}],4:[function(e,t,n){function o(e,t,n){if(!e&&!t&&!n)throw new Error("Missing required arguments");if(!c.string(t))throw new TypeError("Second argument must be a String");if(!c.fn(n))throw new TypeError("Third argument must be a Function");if(c.node(e))return i(e,t,n);if(c.nodeList(e))return r(e,t,n);if(c.string(e))return a(e,t,n);throw new TypeError("First argument must be a String, HTMLElement, HTMLCollection, or NodeList")}function i(e,t,n){return e.addEventListener(t,n),{destroy:function(){e.removeEventListener(t,n)}}}function r(e,t,n){return Array.prototype.forEach.call(e,function(e){e.addEventListener(t,n)}),{destroy:function(){Array.prototype.forEach.call(e,function(e){e.removeEventListener(t,n)})}}}function a(e,t,n){return l(document.body,e,t,n)}var c=e("./is"),l=e("delegate");t.exports=o},{"./is":3,delegate:2}],5:[function(e,t,n){function o(e){var t;if("SELECT"===e.nodeName)e.focus(),t=e.value;else if("INPUT"===e.nodeName||"TEXTAREA"===e.nodeName){var n=e.hasAttribute("readonly");n||e.setAttribute("readonly",""),e.select(),e.setSelectionRange(0,e.value.length),n||e.removeAttribute("readonly"),t=e.value}else{e.hasAttribute("contenteditable")&&e.focus();var o=window.getSelection(),i=document.createRange();i.selectNodeContents(e),o.removeAllRanges(),o.addRange(i),t=o.toString()}return t}t.exports=o},{}],6:[function(e,t,n){function o(){}o.prototype={on:function(e,t,n){var o=this.e||(this.e={});return(o[e]||(o[e]=[])).push({fn:t,ctx:n}),this},once:function(e,t,n){function o(){i.off(e,o),t.apply(n,arguments)}var i=this;return o._=t,this.on(e,o,n)},emit:function(e){var t=[].slice.call(arguments,1),n=((this.e||(this.e={}))[e]||[]).slice(),o=0,i=n.length;for(o;o<i;o++)n[o].fn.apply(n[o].ctx,t);return this},off:function(e,t){var n=this.e||(this.e={}),o=n[e],i=[];if(o&&t)for(var r=0,a=o.length;r<a;r++)o[r].fn!==t&&o[r].fn._!==t&&i.push(o[r]);return i.length?n[e]=i:delete n[e],this}},t.exports=o},{}],7:[function(t,n,o){!function(i,r){if("function"==typeof e&&e.amd)e(["module","select"],r);else if("undefined"!=typeof o)r(n,t("select"));else{var a={exports:{}};r(a,i.select),i.clipboardAction=a.exports}}(this,function(e,t){"use strict";function n(e){return e&&e.__esModule?e:{default:e}}function o(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var i=n(t),r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},a=function(){function e(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}return function(t,n,o){return n&&e(t.prototype,n),o&&e(t,o),t}}(),c=function(){function e(t){o(this,e),this.resolveOptions(t),this.initSelection()}return a(e,[{key:"resolveOptions",value:function e(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.action=t.action,this.emitter=t.emitter,this.target=t.target,this.text=t.text,this.trigger=t.trigger,this.selectedText=""}},{key:"initSelection",value:function e(){this.text?this.selectFake():this.target&&this.selectTarget()}},{key:"selectFake",value:function e(){var t=this,n="rtl"==document.documentElement.getAttribute("dir");this.removeFake(),this.fakeHandlerCallback=function(){return t.removeFake()},this.fakeHandler=document.body.addEventListener("click",this.fakeHandlerCallback)||!0,this.fakeElem=document.createElement("textarea"),this.fakeElem.style.fontSize="12pt",this.fakeElem.style.border="0",this.fakeElem.style.padding="0",this.fakeElem.style.margin="0",this.fakeElem.style.position="absolute",this.fakeElem.style[n?"right":"left"]="-9999px";var o=window.pageYOffset||document.documentElement.scrollTop;this.fakeElem.style.top=o+"px",this.fakeElem.setAttribute("readonly",""),this.fakeElem.value=this.text,document.body.appendChild(this.fakeElem),this.selectedText=(0,i.default)(this.fakeElem),this.copyText()}},{key:"removeFake",value:function e(){this.fakeHandler&&(document.body.removeEventListener("click",this.fakeHandlerCallback),this.fakeHandler=null,this.fakeHandlerCallback=null),this.fakeElem&&(document.body.removeChild(this.fakeElem),this.fakeElem=null)}},{key:"selectTarget",value:function e(){this.selectedText=(0,i.default)(this.target),this.copyText()}},{key:"copyText",value:function e(){var t=void 0;try{t=document.execCommand(this.action)}catch(e){t=!1}this.handleResult(t)}},{key:"handleResult",value:function e(t){this.emitter.emit(t?"success":"error",{action:this.action,text:this.selectedText,trigger:this.trigger,clearSelection:this.clearSelection.bind(this)})}},{key:"clearSelection",value:function e(){this.target&&this.target.blur(),window.getSelection().removeAllRanges()}},{key:"destroy",value:function e(){this.removeFake()}},{key:"action",set:function e(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"copy";if(this._action=t,"copy"!==this._action&&"cut"!==this._action)throw new Error('Invalid "action" value, use either "copy" or "cut"')},get:function e(){return this._action}},{key:"target",set:function e(t){if(void 0!==t){if(!t||"object"!==("undefined"==typeof t?"undefined":r(t))||1!==t.nodeType)throw new Error('Invalid "target" value, use a valid Element');if("copy"===this.action&&t.hasAttribute("disabled"))throw new Error('Invalid "target" attribute. Please use "readonly" instead of "disabled" attribute');if("cut"===this.action&&(t.hasAttribute("readonly")||t.hasAttribute("disabled")))throw new Error('Invalid "target" attribute. You can\'t cut text from elements with "readonly" or "disabled" attributes');this._target=t}},get:function e(){return this._target}}]),e}();e.exports=c})},{select:5}],8:[function(t,n,o){!function(i,r){if("function"==typeof e&&e.amd)e(["module","./clipboard-action","tiny-emitter","good-listener"],r);else if("undefined"!=typeof o)r(n,t("./clipboard-action"),t("tiny-emitter"),t("good-listener"));else{var a={exports:{}};r(a,i.clipboardAction,i.tinyEmitter,i.goodListener),i.clipboard=a.exports}}(this,function(e,t,n,o){"use strict";function i(e){return e&&e.__esModule?e:{default:e}}function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function a(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function c(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}function l(e,t){var n="data-clipboard-"+e;if(t.hasAttribute(n))return t.getAttribute(n)}var u=i(t),s=i(n),f=i(o),d=function(){function e(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}return function(t,n,o){return n&&e(t.prototype,n),o&&e(t,o),t}}(),h=function(e){function t(e,n){r(this,t);var o=a(this,(t.__proto__||Object.getPrototypeOf(t)).call(this));return o.resolveOptions(n),o.listenClick(e),o}return c(t,e),d(t,[{key:"resolveOptions",value:function e(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.action="function"==typeof t.action?t.action:this.defaultAction,this.target="function"==typeof t.target?t.target:this.defaultTarget,this.text="function"==typeof t.text?t.text:this.defaultText}},{key:"listenClick",value:function e(t){var n=this;this.listener=(0,f.default)(t,"click",function(e){return n.onClick(e)})}},{key:"onClick",value:function e(t){var n=t.delegateTarget||t.currentTarget;this.clipboardAction&&(this.clipboardAction=null),this.clipboardAction=new u.default({action:this.action(n),target:this.target(n),text:this.text(n),trigger:n,emitter:this})}},{key:"defaultAction",value:function e(t){return l("action",t)}},{key:"defaultTarget",value:function e(t){var n=l("target",t);if(n)return document.querySelector(n)}},{key:"defaultText",value:function e(t){return l("text",t)}},{key:"destroy",value:function e(){this.listener.destroy(),this.clipboardAction&&(this.clipboardAction.destroy(),this.clipboardAction=null)}}],[{key:"isSupported",value:function e(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:["copy","cut"],n="string"==typeof t?[t]:t,o=!!document.queryCommandSupported;return n.forEach(function(e){o=o&&!!document.queryCommandSupported(e)}),o}}]),t}(s.default);e.exports=h})},{"./clipboard-action":7,"good-listener":4,"tiny-emitter":6}]},{},[8])(8)});
/*!
 * jQuery Plugin: Are-You-Sure (Dirty Form Detection)
 * https://github.com/codedance/jquery.AreYouSure/
 *
 * Copyright (c) 2012-2014, Chris Dance and PaperCut Software http://www.papercut.com/
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * Author:  chris.dance@papercut.com
 * Version: 1.9.0
 * Date:    13th August 2014
 */
(function($) {
  
  $.fn.areYouSure = function(options) {
      
    var settings = $.extend(
      {
        'message' : 'You have unsaved changes!',
        'dirtyClass' : 'dirty',
        'change' : null,
        'silent' : false,
        'addRemoveFieldsMarksDirty' : false,
        'fieldEvents' : 'change keyup propertychange input',
        'fieldSelector': ":input:not(input[type=submit]):not(input[type=button])"
      }, options);

    var getValue = function($field) {
      if ($field.hasClass('ays-ignore')
          || $field.hasClass('aysIgnore')
          || $field.attr('data-ays-ignore')
          || $field.attr('name') === undefined) {
        return null;
      }

      if ($field.is(':disabled')) {
        return 'ays-disabled';
      }

      var val;
      var type = $field.attr('type');
      if ($field.is('select')) {
        type = 'select';
      }

      switch (type) {
        case 'checkbox':
        case 'radio':
          val = $field.is(':checked');
          break;
        case 'select':
          val = '';
          $field.find('option').each(function(o) {
            var $option = $(this);
            if ($option.is(':selected')) {
              val += $option.val();
            }
          });
          break;
        default:
          val = $field.val();
      }

      return val;
    };

    var storeOrigValue = function($field) {
      $field.data('ays-orig', getValue($field));
    };

    var checkForm = function(evt) {

      var isFieldDirty = function($field) {
        var origValue = $field.data('ays-orig');
        if (undefined === origValue) {
          return false;
        }
        return (getValue($field) != origValue);
      };

      var $form = ($(this).is('form')) 
                    ? $(this)
                    : $(this).parents('form');

      // Test on the target first as it's the most likely to be dirty
      if (isFieldDirty($(evt.target))) {
        setDirtyStatus($form, true);
        return;
      }

      $fields = $form.find(settings.fieldSelector);

      if (settings.addRemoveFieldsMarksDirty) {              
        // Check if field count has changed
        var origCount = $form.data("ays-orig-field-count");
        if (origCount != $fields.length) {
          setDirtyStatus($form, true);
          return;
        }
      }

      // Brute force - check each field
      var isDirty = false;
      $fields.each(function() {
        $field = $(this);
        if (isFieldDirty($field)) {
          isDirty = true;
          return false; // break
        }
      });
      
      setDirtyStatus($form, isDirty);
    };

    var initForm = function($form) {
      var fields = $form.find(settings.fieldSelector);
      $(fields).each(function() { storeOrigValue($(this)); });
      $(fields).unbind(settings.fieldEvents, checkForm);
      $(fields).bind(settings.fieldEvents, checkForm);
      $form.data("ays-orig-field-count", $(fields).length);
      setDirtyStatus($form, false);
    };

    var setDirtyStatus = function($form, isDirty) {
      var changed = isDirty != $form.hasClass(settings.dirtyClass);
      $form.toggleClass(settings.dirtyClass, isDirty);
        
      // Fire change event if required
      if (changed) {
        if (settings.change) settings.change.call($form, $form);

        if (isDirty) $form.trigger('dirty.areYouSure', [$form]);
        if (!isDirty) $form.trigger('clean.areYouSure', [$form]);
        $form.trigger('change.areYouSure', [$form]);
      }
    };

    var rescan = function() {
      var $form = $(this);
      var fields = $form.find(settings.fieldSelector);
      $(fields).each(function() {
        var $field = $(this);
        if (!$field.data('ays-orig')) {
          storeOrigValue($field);
          $field.bind(settings.fieldEvents, checkForm);
        }
      });
      // Check for changes while we're here
      $form.trigger('checkform.areYouSure');
    };

    var reinitialize = function() {
      initForm($(this));
    }

    if (!settings.silent && !window.aysUnloadSet) {
      window.aysUnloadSet = true;
      $(window).bind('beforeunload', function() {
        $dirtyForms = $("form").filter('.' + settings.dirtyClass);
        if ($dirtyForms.length == 0) {
          return;
        }
        // Prevent multiple prompts - seen on Chrome and IE
        if (navigator.userAgent.toLowerCase().match(/msie|chrome/)) {
          if (window.aysHasPrompted) {
            return;
          }
          window.aysHasPrompted = true;
          window.setTimeout(function() {window.aysHasPrompted = false;}, 900);
        }
        return settings.message;
      });
    }

    return this.each(function(elem) {
      if (!$(this).is('form')) {
        return;
      }
      var $form = $(this);
        
      $form.submit(function() {
        $form.removeClass(settings.dirtyClass);
      });
      $form.bind('reset', function() { setDirtyStatus($form, false); });
      // Add a custom events
      $form.bind('rescan.areYouSure', rescan);
      $form.bind('reinitialize.areYouSure', reinitialize);
      $form.bind('checkform.areYouSure', checkForm);
      initForm($form);
    });
  };
})(jQuery);

/**
 * JS for the collection edit screen
 */

(function( $ ) {
	'use strict';

	/**
	 * Switch radio tabs
	 */
	$( '.js-picu-share-select li a' ).click( function( e ) {
		e.preventDefault();
		$( '.js-picu-share-select li a' ).removeClass( 'active' );
		$( this ).addClass( 'active' );

		var target = $( this ).prop( 'hash' );
		$( '.picu-share-option' ).removeClass( 'is-active' );
		$( target ).addClass( 'is-active' );
		$( '.js-picu_collection_share_method' ).val( target.substr(1) );

		$( '#picu-password .picu-hint' ).toggleClass( 'is-hidden' );

		// Change publish button text
		if ( target == '#picu-copy-link' ) {
			$( '[name=picu_sendmail]' ).val( picu_admin.button_text_publish );
		}
		else {
			$( '[name=picu_sendmail]' ).val( picu_admin.button_text_send_to_client );
		}
	});

	$( '.js-toggle-picu-gallery-height' ).click( function( e ) {
		e.preventDefault();
		$( '.picu-gallery-has-images' ).toggleClass( 'js-collapsed' );
		$( this ).parent().toggleClass( 'active' );
	});

    $( '#picu-collection-link' ).click( function() {
       $( this ).select();
    });


    /**
     * Toggle password field
     */
    $( '.picu-option-item > a' ).click( function( e ) {
        e.preventDefault();
        $( this ).next( '.picu-option-content' ).toggleClass( 'is-hidden' );
    });

    if ( $( '#post_password' ).length >= 1 && $( '#post_password').val().length > 0 ) {
        $( '.picu-remove-password' ).removeClass( 'is-hidden' );
    }

    // Change password ui depending if a password is set or not
    $( '#post_password' ).keyup( function() {

        if ( $( '#post_password').val().length > 0 ) {
            $( '.picu-remove-password' ).removeClass( 'is-hidden' );
            $( '.picu-option-item a .dashicons' ).removeClass( 'dashicons-unlock' ).addClass( 'dashicons-lock' );
        }
        else {
            $( '.picu-remove-password' ).addClass( 'is-hidden' );
            $( '.picu-option-item a .dashicons' ).removeClass( 'dashicons-lock' ).addClass( 'dashicons-unlock' );
        }

    });

    // Remove password via click
    $( '.js-picu-remove-password' ).click( function( e ) {
        e.preventDefault();
        $( '#picu-password #post_password' ).val( '' );
        $( '.picu-option-item a .dashicons' ).removeClass( 'dashicons-lock' ).addClass( 'dashicons-unlock' );
        $( this ).addClass( 'is-hidden' );
    });

    $( '.js-picu-edit' ).click( function( e ) {
        e.preventDefault();
        $( '#js-picu-edit' ).removeClass( 'is-hidden' );
    });

	// Open duplication modal
	$( '.js-picu-duplicate' ).click( function( e ) {
		e.preventDefault();
		var id = $( this ).attr( 'data-id' );
		$( '#js-picu-duplicate-' + id ).removeClass( 'is-hidden' );
	});

	// Switch duplication button url
	$( 'input[type=radio][name^=picu_duplicate_]' ).change( function() {
		var id = $( this ).attr( 'data-id' );

		console.log( this.value );

		// Get the right url
		if ( this.value == 'selected' ) {
			var href = $( '[name=picu_duplication_url_' + id + ']' ).val() + '&picu_duplicate_collection_selected=1';
		}
		else if ( this.value == 'not-selected' ) {
			var href = $( '[name=picu_duplication_url_' + id + ']' ).val() + '&picu_duplicate_collection_not_selected=1';
		}
		else {
			var href = $( '[name=picu_duplication_url_' + id + ']' ).val();
		}

		// Change button (link) url
		$( '.js-picu-duplication-button-' + id ).attr( 'href', href );
	});


	// Cancel modal
	$( '.js-picu-cancel-modal' ).click( function( e ) {
		e.preventDefault();
		$( this ).parents( '.picu-modal' ).addClass( 'is-hidden' );
	});


	// Replace collection description with custom message
	$( '.js-picu-select-custom-message' ).change( function( e ){
		$( '.js-picu-collection-description' ).val( $( this ).val() );
	});

	// Reset selected option when description changes
	$( '.js-picu-collection-description' ).bind( 'input propertychange', function() {
		if( this.value.length ) {
			$( '.js-picu-select-custom-message option:first-child' ).attr( 'selected', 'selected' );
		}
	});


	/**
	 * Save per collection watermark setting
	 */
	$( '#picu-apply-watermark' ).click( function( e ) {
		$( '.picu-watermark-saving-indicator' ).removeClass( 'is-saved' ).addClass( 'is-saving' );
		saveCustomWatermarkState();
	});


	function saveCustomWatermarkState() {
		// Gather all the data
		var postID = $( '#post_ID' ).val();
		if ( $( '#picu-apply-watermark' )[0].checked ) {
			var watermarkState = 'on';
		}
		else {
			var watermarkState = 'off';
		}
		
		// Send ajax request
		$.post( picu_admin.ajaxurl, {
			action: 'picu_save_watermark_state',
			security: picu_admin.ajax_nonce,
			post_id: postID,
			picu_apply_watermark: watermarkState,

		}, function( response ) {
			// Ajax success
			$( '.picu-watermark-saving-indicator' ).removeClass( 'is-saving' ).addClass( 'is-saved' );
		}).fail( function() {
			// TODO Ajax fail
			console.log( 'Saving failed' );
		});
	}

})( jQuery );
/**
 * Custom media uploader for picu uploads
 *
 */

//Setup media frame
var picu_delivery_uploader = wp.media({
	state: 'gallery-edit',
	frame: 'post'
});

// Change title and button text
picu_delivery_uploader.states.models[4].attributes.title = picu_admin.media_modal_title;
_wpMediaViewsL10n.insertGallery = picu_admin.media_modal_button_insert_text;


if ( picu_delivery_uploader ) {

	wp.media.model.settings.post.id = picu_admin.postID;

	picu_delivery_uploader.on('open', function() {

		// check if there is a gallery shortcode in our hidden input field
		if ( jQuery('#delivery_image_ids').val() ) {

			// add the ids from the shortcode to a variable
			var images = jQuery('#delivery_image_ids').val();

			// split them up to get separate id's
			var image_ids = images.split( ',' );

			// load the initial library for our media frame
			var library = picu_delivery_uploader.state().get( 'library' );

			// loop through our image ids and add them to the library
			image_ids.forEach( function( id ) {
				attachment = wp.media.attachment( id );
				attachment.fetch();
				library.add( attachment ? [ attachment ] : [] );
			});

		}

		// Add a custom class, we don't want to break any other plugins
		jQuery('.media-modal').addClass('picu-upload-modal');

	});


	picu_delivery_uploader.on( 'update', function( selection ) {

		// define an empty image array
		var images = [];

		// clean our thumbnail wrapper to avoid duplicates
		jQuery( '.picu-gallery-thumbnails' ).empty();

		// iterrate through the selection from the media modal
		// and add images to the images array
		selection.each( function( attachment ) {
			images.push( attachment.toJSON().id );

			// add thumbnails to the thumbnail wrapper
			var url = '';
			if ( attachment.toJSON().sizes['picu-small'] ) {
				url = attachment.toJSON().sizes['picu-small'].url;
			}
			else {
				url = attachment.toJSON().sizes['full'].url;
			}
			jQuery( '.picu-gallery-thumbnails' ).append( '<figure><div class="picu-gallery-thumbnail-box"><div class="picu-gallery-thumbnail-box-inner"><img src="' + url + '" class="attachment-picu-thumbnail" alt="" title=""></div></div></figure>' );

		});

		// show the thumbnail-wrapper
		// jQuery( '.picu-gallery-thumbnails' ).show();
		jQuery( '.picu-postbox' ).addClass( 'picu-gallery-has-images' );

		//
		if ( images.length > 10 ) {
			jQuery( '.picu-postbox' ).addClass( 'js-collapsed is-collapsible' );
		}

		// create the final gallery string (comma-separated id's)
		var shortcode = images.join(',');

		// add the shortcode to our hidden input field
		jQuery( '#delivery_image_ids' ).val( shortcode );

		// Letting jQuery.AreYouSure know, that something changed in our form
		// so we can output a message when someone leaves without saving
		jQuery( '#post' ).addClass( 'dirty' );

	});

}

jQuery(document).ready( function() {

	// open the uploader frame when the button is clicked
	jQuery( '.picu-upload-delivery-button' ).on( 'click', function( e ) {
		// we don't want to follow the clicked link
		e.preventDefault();

		// open our media frame
		picu_delivery_uploader.open();
	});

	// Also open our media frame, when an image is drag&dropped
	jQuery( '.picu-postbox-inner' ).on( 'drop', function() {
		picu_delivery_uploader.open();
	});

});
/**
 * JS for the settings page(s)
 */

(function( $ ) {
	'use strict';

	/**
	 * Call the media uploader
	 */
	$( '.add_logo' ).on( 'click', function( evt ) {
		// Stop the anchor's default behavior
		evt.preventDefault();
		// Display the media uploader
		renderMediaUploader();
	});

	function renderMediaUploader() {

		var file_frame, image_data, json;

		/**
		 * Use existing instance
		 */
		if ( undefined !== file_frame ) {
			file_frame.open();
			return;
		}

		/**
		 * Create new instance
		 */
		file_frame = wp.media.frames.file_frame = wp.media({
			frame: 'post',
			state: 'insert',
			multiple: false
		});

		/**
		 * Return data
		 */
		file_frame.on( 'insert', function( selection ) {

			json = file_frame.state().get( 'selection' ).first().toJSON();

			// Make sure url exists
			if ( 0 > jQuery.trim( json.url.length ) ) {
				return;
			}

			// After that, set the properties of the image and display it
			$( '.preview-logo' ).remove();
			$( '.collection-preview' ).prepend( '<img src="' + json.url + '" class="preview-logo" alt="logo" />' );
			$( '#logo' ).val( json.url );
			$( '.ui-upload' ).removeClass( 'active' );
			$( '.ui-replace-remove' ).addClass( 'active' );

		});

		// Open media uploader
		file_frame.open();
	}


	/*
	 * Remove logo
	 */
	$( '#remove_logo' ).click( function( e ) {
		e.preventDefault();
		$( '.preview-logo' ).remove();
		$( '#logo' ).val( '' );
		$( '.ui-upload' ).addClass( 'active' );
		$( '.ui-replace-remove' ).removeClass( 'active' );
	});


	/*
	 * Show / hide blog title
	 */
	$( '#show_blog_title' ).on('change', function() {
		if ( $( this ).prop('checked') ) {
			$( '.blog-name' ).addClass( 'active' );
		}
		else {
			$( '.blog-name' ).removeClass( 'active' );
		}
	});


	/**
	 * Switch radio tabs
	 */
	$( '.js-radio-tab li a' ).click( function( e ) {
		e.preventDefault();
		$( '.js-radio-tab li a' ).removeClass( 'active' );
		$( this ).addClass( 'active' );

		var target = $( this ).prop( 'hash' );
		$( '.radio-tab-box' ).removeClass( 'is-active' );
		$( target ).addClass( 'is-active' );
		$( '.js-picu_bc_font_method' ).val( target.substr(1) );
	});


	/*
	 * Change font
	 */
	$( '#font' ).on( 'change', function() {
		$( '#font option:selected' ).each( function(){
			var font = $( this ).val();
			$( '.collection-preview' ).find( 'style' ).remove();
			$( '.collection-preview' ).before( '<style>.collection-preview { font-family: ' + font + ' }</style>' );
		});
	});


	/*
	 * Add color picker
	 */
	$( '.color-field' ).wpColorPicker();


	/*
	 * Add color picker
	 */
	$( '#show_file_names' ).on('change', function() {
		if ( $( this ).prop('checked') ) {
			$( '#show_file_extensions' ).prop( 'disabled', false );
		}
		else {
			$( '#show_file_extensions' ).prop( 'disabled', true );
		}
	});


	/*
	 * Title composition
	 */
	function updateTitleComposition() {
		var temp = [];
		var elements = $( '.js-picu-image-title-composition span' );
		_.each( elements, function( e ) {
			temp.push( '[' + $( e ).attr( 'id' ) + ']' );
		});
		$( '.js-picu-file-name-comp' ).val( temp.join( ' ' ) );
	}

	$( '.js-picu-image-title-composition' ).sortable({
		revert: true,
		containment: 'parent',
		stop: function() {
			updateTitleComposition();
		}
	});

	$( '.js-picu-image-title-sources span' ).draggable({
		connectToSortable: '.js-picu-image-title-composition',
		appendTo: 'parent',
		helper: 'clone',
		revert: 'invalid',
		stop: function( e, ui ) {
			var sourceID = $( this ).attr( 'id' );
			$( '.js-picu-image-title-composition .new' ).append( '<a class="picu-title-comp-remove js-picu-title-comp-remove" href="#">Remove title part</a>').removeClass( 'new' ).css( 'width', 'auto' ).attr( 'id', sourceID );
		}
	});

	$( '.js-picu-image-title-sources, .js-picu-image-title-sources span' ).disableSelection();

	$( '.js-picu-image-title-composition' ).on( 'click', '.js-picu-title-comp-remove', function( e ){
		e.preventDefault();
		$( this ).parents( 'span' ).remove();
		updateTitleComposition();
	});



	/**
	 * Multiple email messages
	 */
	var originalMessageName = '';
	var originalMessageBody = '';

	// Save as default message
	$( document ).on( 'click', '.picu-custom-email-messages-table tr td:first-child svg', function( e ){
		e.preventDefault();
		if ( $( this ).parents( 'tr' ).hasClass( 'default-message' ) ) {
			$( this ).parents( 'tr' ).removeClass( 'default-message' );
		}
		else {
			$( '.picu-custom-email-messages-table tr' ).removeClass( 'default-message' );
			$( this ).parents( 'tr' ).addClass( 'default-message' );
		}
		saveCustomEmailMessages();
	});

	$( document ).on( 'click', '.js-edit-picu-message', function( e ){
		e.preventDefault();

		// Save current values
		originalMessageName = $( this ).parents( 'td' ).children( '.picu-message-edit-box' ).children( '.picu-message-name' ).val();
		originalMessageBody = $( this ).parents( 'td' ).children( '.picu-message-edit-box' ).children( '.picu-message-body' ).val();

		$( '.picu-custom-email-messages-table tr' ).removeClass( 'edit-active' );
		$( this ).parents( 'tr' ).addClass( 'edit-active' );
	});

	$( document ).on( 'click', '.picu-message-name-title', function( e ){
		e.preventDefault();

		// Save current values
		originalMessageName = $( this ).parents( 'td' ).children( '.picu-message-edit-box' ).children( '.picu-message-name' ).val();
		originalMessageBody = $( this ).parents( 'td' ).children( '.picu-message-edit-box' ).children( '.picu-message-body' ).val();

		$( '.picu-custom-email-messages-table tr' ).removeClass( 'edit-active' );
		$( this ).parents( 'tr' ).addClass( 'edit-active' );
		$( this ).parents( 'td' ).children( '.picu-message-edit-box' ).children( '.picu-message-name' ).focus();
	});

	$( document ).on( 'click', '.js-cancel-picu-message', function( e ){
		e.preventDefault();

		if ( $( this ).parents( '.picu-message-edit-box' ).parents( 'td' ).parents( 'tr' ).hasClass( 'new' ) ) {
			$( this ).parents( 'tr' ).remove();
		}

		// Revert to original values
		$( this ).parents( 'td' ).children( '.picu-message-edit-box' ).children( '.picu-message-name' ).val( originalMessageName );
		$( this ).parents( 'td' ).children( '.picu-message-edit-box' ).children( '.picu-message-body' ).val( originalMessageBody );

		if ( $( this ).parents( 'td' ).children( '.picu-message-name' ).html() == '' && $( this ).parents( 'td' ).children( '.picu-message-edit-box' ).children( '.picu-message-body' ).val() == '' ) {
			$( this ).parents( 'tr' ).remove();
		}
		else {
			$( '.picu-custom-email-messages-table tr' ).removeClass( 'edit-active' );
		}
	});

	$( document ).on( 'click', '.js-save-picu-message', function( e ){
		e.preventDefault();

		var templateName = $( this ).parents( 'td' ).children( '.picu-message-edit-box' ).children( '.picu-message-name' ).val();

		if ( ! templateName ) {
			window.alert( picu_admin.empty_template_name_hint );
			$( this ).parents( 'td' ).children( '.picu-message-edit-box' ).children( '.picu-message-name' ).focus();
			return;
		}

		$( this ).parents( 'td' ).children( '.picu-message-name-title' ).html( templateName );
		$( '.picu-custom-email-messages-table tr' ).removeClass( 'edit-active' );
		$( this ).parents( 'tr' ).removeClass( 'new' );
		saveCustomEmailMessages();
	});

	$( document ).on( 'click', '.js-delete-picu-message', function( e ){
		e.preventDefault();
		$( this ).parents( 'tr' ).remove();
		saveCustomEmailMessages();
	});

	$( '.js-add-picu-message' ).click( function( e ){
		e.preventDefault();

		// Reset temporary save values
		originalMessageName = '';
		originalMessageBody = '';

		$( '.picu-custom-email-messages-table tbody' ).append( '<tr class="picu-message edit-active new"><td><svg xmlns="http://www.w3.org/2000/svg" width="14" height="14" viewBox="0 0 24 24" stroke-width="2" stroke-linecap="square" stroke-linejoin="arcs"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg></td><td colspan="2"><div id="picu-message-name" class="picu-message-name-title" contenteditable="true"></div><div class="picu-message-edit-box"><input type="text" class="picu-message-name" /><textarea id="picu-message-body" class="picu-message-body"></textarea> <button class="button button-primary js-save-picu-message">' + picu_admin.button_text_save_message +'</button> <button class="button button js-cancel-picu-message">' + picu_admin.button_text_cancel + '</button></div><div class="picu-message-actions"><a class="js-edit-picu-message" href="#">' + picu_admin.link_text_edit + '</a> | <a class="js-delete-picu-message" href="#">' + picu_admin.link_text_delete + '</a></div></td></tr>' );

		$( '.edit-active td:nth-child(2) .picu-message-name').focus();
	});

	$( document ).on( 'keypress', '.picu-message-name', function( e ){
		if ( e.keyCode == 13 ) {
			e.preventDefault();
			$( this ).next().focus();
		}
	});

	function saveCustomEmailMessages() {
		// Gather all the data
		var messages = [];
		var elements = $( '.picu-custom-email-messages-table tbody tr' );
		elements;
		_.each( elements, function( e ) {
			if ( $( e ).hasClass( 'default-message' ) ) {
				var message_default = 1;
			}
			else {
				var message_default = 0;
			}
			var name = $( e ).children( 'td:nth-child(2)' ).children( '.picu-message-edit-box' ).children( '.picu-message-name').val();
			var body = $( e ).children( 'td:nth-child(2)' ).children( '.picu-message-edit-box' ).children( '.picu-message-body').val();

			messages.push( {
				'message_name': name,
				'message_body': body,
				'message_default': message_default
			} );
		});

		$( '.picu-message-saving' ).removeClass( 'is-saved' );
		$( '.picu-message-saving' ).addClass( 'is-saving' );

		// Send ajax request
		$.post( picu_admin.ajaxurl, {
			action: 'picu_save_custom_email_messages',
			security: picu_admin.ajax_nonce,
			picu_email_templates: messages,

		}, function( response ) {
			// Ajax success
			$( '.picu-message-saving' ).removeClass( 'is-saving' );
			$( '.picu-message-saving' ).addClass( 'is-saved' );
		}).fail( function() {
			// TODO Ajax fail
			console.log( 'Saving failed' );
		});
	}



	/**
	 * Prevent from enter presses triggering the wrong submit button on the license screen
	 */
	$( 'input[name^="picu_addon_licenses"]' ).on( 'keypress', '', function( e ){
		if ( e.keyCode == 13 ) {
			e.preventDefault();
			$( e.currentTarget ).next().next().trigger( 'click' );
		}
	});



	/*
	 * Theft Protection
	 */

	 /**
 	 * Add watermark image (call the media uploader)
 	 */
 	$( '#picu-settings-theft-protection .add_watermark' ).on( 'click', function( evt ) {
 		// Stop the anchor's default behavior
 		evt.preventDefault();
 		// Display the media uploader
 		renderMediaUploaderWatermark();
	});


	/**
	 * Initial watermark calculation on page load
	 */
	var watermarkWidth, watermarkHeight;

	if  ( $( '.js-watermark-positioned' ).length > 0 ) {
		var img = $( '.js-watermark-positioned' )[0];
		$( '<img/>' ).attr( 'src', $( img ).attr( 'src' ) ).load( function() {
			watermarkWidth = this.naturalWidth;
			watermarkHeight = this.naturalHeight;
			calculateWatermark( watermarkWidth, watermarkHeight );
		});
	}

	/**
	 * Open media upload layover
	 */
 	function renderMediaUploaderWatermark() {

 		var file_frame, image_data, json;

 		/**
 		 * Use existing instance
 		 */
 		if ( undefined !== file_frame ) {
 			file_frame.open();
 			return;
 		}

 		/**
 		 * Create new instance
 		 */
 		file_frame = wp.media.frames.file_frame = wp.media({
 			frame: 'post',
 			state: 'insert',
 			multiple: false
 		});

 		/**
 		 * Return data
 		 */
 		file_frame.on( 'insert', function( selection ) {

 			json = file_frame.state().get( 'selection' ).first().toJSON();

 			// Make sure url exists
 			if ( 0 > jQuery.trim( json.url.length ) ) {
 				return;
 			}

 			// After that, set the properties of the image and display it
			$( '.js-watermark-positioned' ).remove();
			$( '.js-watermark-shadow' ).remove();
			$( '#picu-settings-theft-protection .watermark-position' ).append( '<img src="' + json.url + '" class="picu-watermark-positioned js-watermark-positioned" alt="watermark" /><img src="' + json.url + '" class="watermark-shadow js-watermark-shadow" alt="" />' );
			
			//Caclulate image width height new!
			var img = $( '.js-watermark-positioned' )[0]; // Get my img elem
			$("<img/>").attr( 'src', $( img ).attr( 'src') ).load( function() {
        		watermarkWidth = this.naturalWidth;
				watermarkHeight = this.naturalHeight;
				calculateWatermark( watermarkWidth, watermarkHeight );
			});

			$( '#watermark' ).val( json.id );
			$( '.js-picu-watermark-size-scaling-wrap' ).addClass( 'has-watermark' );
 			$( '#picu-settings-theft-protection .ui-upload' ).removeClass( 'active' );
 			$( '#picu-settings-theft-protection .ui-replace-remove' ).addClass( 'active' );

 		});

 		// Open media uploader
 		file_frame.open();
 	}

 	/**
 	 * Remove the watermark
 	 */
 	$( '#picu-settings-theft-protection #remove_watermark' ).click( function( e ) {
 		e.preventDefault();
 		$( '.js-watermark-positioned' ).remove();
		$( '#watermark' ).val( '' );
		$( '.js-picu-watermark-size-scaling-wrap' ).removeClass( 'has-watermark' );
 		$( '#picu-settings-theft-protection .ui-upload' ).addClass( 'active' );
 		$( '#picu-settings-theft-protection .ui-replace-remove' ).removeClass( 'active' );
 	});


	/**
	 * Calculate watermark size, add negative margins for correct positioning
	 * 
	 * @param {integer} watermarkWidth 
	 * @param {integer} watermarkHeight 
	 */
	function calculateWatermark( watermarkWidth, watermarkHeight ) {
		var size = $( '#watermark_size' ).val();
		var q;

		// Calculate size, if "fit" option is chosen
		if ( $( '.picu-watermark-position-wrap' ).hasClass( 'watermark-fill' ) ) {
			$( '.js-watermark-positioned' ).css( 'width', watermarkWidth );
			$( '.js-watermark-positioned' ).css( 'height', watermarkHeight );
			$( '.js-watermark-positioned' ).css( 'margin-left', -1 * ( watermarkWidth / 2 ) );
			$( '.js-watermark-positioned' ).css( 'margin-top', -1 * ( watermarkHeight / 2 ) );
			return;
		}

		// Calculate size, if "proportional" option is chosen
		if ( watermarkWidth / watermarkHeight > 1 ) { // landscape
			q = watermarkWidth / watermarkHeight;
			$( '.js-watermark-positioned' ).css( 'width', 300 * ( size / 100 ) );
			$( '.js-watermark-positioned' ).css( 'height', 300 / q * ( size / 100 ) );
		}
		else if ( watermarkWidth / watermarkHeight < 1 ) { // portrait
			q = watermarkWidth / watermarkHeight;
			$( '.js-watermark-positioned' ).css( 'width', 300 * q * ( size / 100 ) );
			$( '.js-watermark-positioned' ).css( 'height', 300 * ( size / 100 ) );
		}
		else { // square
			q = 1;
			$( '.js-watermark-positioned' ).css( 'width', 300 * ( size / 100 ) );
			$( '.js-watermark-positioned' ).css( 'height', 300 * ( size / 100 ) );
		}

		var pos = $( '.js-watermark-position:checked' ).val();

		if ( pos == 'top-center' || pos == 'middle-center' || pos == 'bottom-center' ) {
			var tempWidth = $( '.js-watermark-positioned' )[0].width;
			$( '.js-watermark-positioned' ).css( 'margin-left', ( -1 * tempWidth / 2 ) );
		}
		else {
			$( '.js-watermark-positioned' ).css( 'margin-left', 0 );
		}

		if ( pos == 'middle-left' || pos == 'middle-center' || pos == 'middle-right' ) {
			var tempHeight = $( '.js-watermark-positioned' )[0].height;
			$( '.js-watermark-positioned' ).css( 'margin-top', ( -1 * tempHeight / 2 ) );
		}
		else {
			$( '.js-watermark-positioned' ).css( 'margin-top', 0 );
		}

		$( '.watermark-size-percent' ).html( size + '%' );
	}

	/**
	 * Trigger watermark calculation on size or postion changes
	 */
	$( '#watermark_size, .js-watermark-position' ).on( 'change', function() { 
		if  ( $( '.js-watermark-positioned' ).length > 0 ) {
			calculateWatermark( watermarkWidth, watermarkHeight );
		}
	});

	$( '.watermark-position label' ).hover( function( e ) {
		var position = e.currentTarget.control.value;
		var width = $( '.js-watermark-positioned' ).width();
		var height = $( '.js-watermark-positioned' ).height();
		$( '.js-watermark-shadow' ).css( 'width', width + 'px' );
		$( '.js-watermark-shadow' ).css( 'height', height + 'px' );

		if ( position == 'top-left' ) {
			$( '.js-watermark-shadow' ).css( { 'top': '0', 'left': '0' } );
		}
		else if ( position == 'top-center' ) {
			$( '.js-watermark-shadow' ).css( { 'top': '0', 'left': '50%', 'margin-left': ( width / -2 ) + 'px' } );
		}
		else if ( position == 'top-right' ) {
			$( '.js-watermark-shadow' ).css( { 'top': '0', 'right': '0' } );
		}
		else if ( position == 'middle-left' ) {
			$( '.js-watermark-shadow' ).css( { 'top': '50%', 'left': '0', 'margin-top': ( height / -2 ) + 'px' } );
		}
		else if ( position == 'middle-center' ) {
			$( '.js-watermark-shadow' ).css( { 'top': '50%', 'left': '50%', 'margin-left': ( width / -2 ) + 'px', 'margin-top': ( height / -2 ) + 'px' } );
		}
		else if ( position == 'middle-right' ) {
			$( '.js-watermark-shadow' ).css( { 'top': '50%', 'right': '0', 'margin-top': ( height / -2 ) + 'px' } );
		}
		else if ( position == 'bottom-left' ) {
			$( '.js-watermark-shadow' ).css( { 'bottom': '0', 'left': '0' } );
		}
		else if ( position == 'bottom-center' ) {
			$( '.js-watermark-shadow' ).css( { 'bottom': '0', 'left': '50%', 'margin-left': ( width / -2 ) + 'px' } );
		}
		else if ( position == 'bottom-right' ) {
			$( '.js-watermark-shadow' ).css( { 'bottom': '0', 'right': '0' } );
		}

		$( '.js-watermark-shadow' ).show();
	}, function() {
		$( '.js-watermark-shadow' ).hide();
		$( '.js-watermark-shadow' ).removeAttr( 'style' );
	});


	/**
	 * Recalculate watermark size and position if sizing option has changed
	 */
	$( '#watermark_size_proportional, #watermark_size_fill' ).on( 'change', function( e ) {
		var sizing = $( e.target ).val();

		if ( sizing == 'fill' ) {
			$( '.picu-watermark-position-wrap' ).removeClass( 'watermark-proportional' );
			$( '.picu-watermark-position-wrap' ).addClass( 'watermark-fill' );
		}
		else {
			$( '.picu-watermark-position-wrap' ).addClass( 'watermark-proportional' );
			$( '.picu-watermark-position-wrap' ).removeClass( 'watermark-fill' );
		}

		if  ( $( '.js-watermark-positioned' ).length > 0 ) {
			calculateWatermark( watermarkWidth, watermarkHeight );
		}
	});

})( jQuery );
/**
 * Switch between tabs on admin pages
 */

(function( $ ) {
	'use strict';

	/**
	 * Switch to the correct tab on page load
	 */
	if ( window.location.hash ) {
		setTimeout( function() { window.scrollTo(0, 0); }, 1);

		// Switch tab nav
		$( '.nav-tab' ).removeClass( 'nav-tab-active is-active' );
		$( 'a[href$="' + window.location.hash + '"]' ).addClass( 'nav-tab-active is-active' );

		// Switch tab content
		$( '.js-picu-tab-content' ).removeClass( 'is-active' );
		$( window.location.hash ).addClass( 'is-active' );
	} else {
		$( '.nav-tab' ).first().addClass( 'nav-tab-active is-active' );
		$( 'js-picu-tab-content' ).first().addClass( 'is-active' );
	}

	/**
	 * Switch tabs on click
	 */
	$( '.nav-tab' ).click( function( e ) {
		e.preventDefault();
		var clicker = $( this );
		var target = $( this ).prop( 'hash' );

		$( '.nav-tab' ).removeClass( 'nav-tab-active is-active' );
		$( clicker ).addClass( 'nav-tab-active is-active' );
		$( '.js-picu-tab-content' ).removeClass( 'is-active' );
		$( target ).addClass( 'is-active' );
		history.pushState({}, "", target );
	});

	/**
	 * Swtich button
	 */
	$( '.js-tab-switch' ).click( function( e ) {
		e.preventDefault();
		var target = $( this ).prop( 'hash' );
		var clicker = $( '.nav-tab[href="' + target + '"]' );
		$( '.nav-tab' ).removeClass( 'nav-tab-active is-active' );
		$( clicker ).addClass( 'nav-tab-active is-active' );
		$( '.js-picu-tab-content' ).removeClass( 'is-active' );
		$( target ).addClass( 'is-active' );
		history.pushState({}, "", target );

	});

})( jQuery );
/**
 * Custom media uploader for picu uploads
 *
 */

//Setup media frame
var picu_uploader = wp.media({
	state: 'gallery-edit',
	frame: 'post'	
});

// Change title and button text
picu_uploader.states.models[4].attributes.title = picu_admin.media_modal_title;
_wpMediaViewsL10n.insertGallery = picu_admin.media_modal_button_insert_text;


if ( picu_uploader ) {

	wp.media.model.settings.post.id = picu_admin.postID;

	picu_uploader.on('open', function() {

		// check if there is a gallery shortcode in our hidden input field
		if ( jQuery('#picu-gallery-ids' ).val() ) {

			// add the ids from the shortcode to a variable
			var images = jQuery('#picu-gallery-ids').val();

			// split them up to get separate id's
			var image_ids = images.split( ',' );

			// load the initial library for our media frame
			var library = picu_uploader.state().get( 'library' );

			// loop through our image ids and add them to the library
			image_ids.forEach( function( id ) {
				attachment = wp.media.attachment( id );
				attachment.fetch();
				library.add( attachment ? [ attachment ] : [] );
			});

		}

		// Add a custom class, we don't want to break any other plugins
		jQuery('.media-modal').addClass('picu-upload-modal');

	});


	picu_uploader.on( 'update', function( selection ) {

		// define an empty image array
		var images = [];

		// clean our thumbnail wrapper to avoid duplicates
		jQuery( '.picu-gallery-thumbnails' ).empty();

		// iterrate through the selection from the media modal
		// and add images to the images array
		selection.each( function( attachment ) {
			images.push( attachment.toJSON().id );

			// add thumbnails to the thumbnail wrapper
			var url = '';
			if ( attachment.toJSON().sizes['picu-small'] ) {
				url = attachment.toJSON().sizes['picu-small'].url;
			}
			else {
				url = attachment.toJSON().sizes['full'].url;
			}
			jQuery( '.picu-gallery-thumbnails' ).append( '<figure><div class="picu-gallery-thumbnail-box"><div class="picu-gallery-thumbnail-box-inner"><img src="' + url + '" class="attachment-picu-thumbnail" alt="" title=""></div></div></figure>' );

		});

		// show the thumbnail-wrapper
		// jQuery( '.picu-gallery-thumbnails' ).show();
		jQuery( '.picu-postbox' ).addClass( 'picu-gallery-has-images' );

		//
		if ( images.length > 10 ) {
			jQuery( '.picu-postbox' ).addClass( 'js-collapsed is-collapsible' );
		}

		// create the final gallery string (comma-separated id's)
		var shortcode = images.join(',');

		// add the shortcode to our hidden input field
		jQuery( '#picu-gallery-ids' ).val( shortcode );

		// Letting jQuery.AreYouSure know, that something changed in our form
		// so we can output a message when someone leaves without saving
		jQuery( '#post' ).addClass( 'dirty' );

	});

}


jQuery(document).ready( function() {

	// open the uploader frame when the button is clicked
	jQuery( '.picu-upload-image-button' ).on('click', function( e ) {
		// we don't want to follow the clicked link
		e.preventDefault();

		// open our media frame
		picu_uploader.open();
	});

	// Also open our media frame, when an image is drag&dropped
	jQuery( '.picu-postbox-inner' ).on( 'drop', function() {
		picu_uploader.open();
	});

});

// Only make dropzone when collection is not sent or approved
if ( ! jQuery( 'body' ).hasClass( 'post-status-sent' ) && ! jQuery( 'body' ).hasClass( 'post-status-approved' ) && ( jQuery( 'body' ).hasClass( 'post-status-auto-draft' ) ) ) {

	jQuery(document).ready( function() {
		var picuUploaderWindow = new wp.media.view.UploaderWindow({
			controller: {
				trigger: function() {
					// console.log('drop uploader "trigger" event');
				},
				on: function() {
					// console.log('drop uploader "on" event');
				}
			},
			uploader: {
				dropzone: jQuery('.picu-postbox-inner')
			}
		}).render();

		picuUploaderWindow.ready();

		jQuery('.picu-postbox-inner').append( picuUploaderWindow.el );
	});

}
/*
 * Functionality for our post edit screen
 */
(function( $ ) {
	'use strict';

	$( '.picu-filter select' ).change( function( e ) {
		$( '.picu-selection-overview-table tbody tr' ).show();
		$( '.picu-selection-overview-table tbody tr.no-match' ).remove();

		var target = $( '.picu-filter select' ).val();

		if ( target == 'all' ) {
			$( '.picu-selection-overview-table tbody tr' ).show();
		}
		else if ( target == 'not-selected' ) {
			$( '.picu-selection-overview-table tbody tr.selected' ).hide();
		}
		else {
			$( '.picu-selection-overview-table tbody tr' ).not( '.' + target ).hide();
		}

		if ( $( '.picu-selection-overview-table tbody tr' ).filter(':visible').length <= 0 ) {
			var columns = $( '.picu-selection-overview-table thead tr th' ).length;
			console.log( columns );
			$( '.picu-selection-overview-table tbody' ).append( '<tr class="no-match"><td colspan="' + columns + '">' + picu_admin.selection_table_no_match + '</td></tr>');
		}
	});

	$( '.js-copy-file-names' ).click( function( e ) {
		var text = $( this ).data( 'clip' );
		e.preventDefault();
		window.prompt( "Copy to clipboard: Ctrl+C, Enter", text );
	});


	$( '#publish' ).click( function() {
		$( '#major-publishing-actions .spinner' ).show();
	});

	$( '#save-post' ).click( function() {
		$( '#major-publishing-actions .spinner' ).show();
	});

	$( '.picu-show-collection-description a' ).click( function( e ) {
		e.preventDefault();
		$( '.picu-approval-message' ).addClass( 'hidden' );
		$( '.picu-collection-description' ).toggleClass( 'hidden' );
	});

	$( '.picu-show-approval-message a' ).click( function( e ) {
		e.preventDefault();
		$( '.picu-collection-description' ).addClass( 'hidden' );
		$( '.picu-approval-message' ).toggleClass( 'hidden' );
	});


	// Check for form Changes with $.AreYourSure and output an error
	$( 'form#post' ).areYouSure( { 'message':'Your changes will be lost, do you want to continue?' } );


	// Collapse control for collection options
	$( '.js-collapse-control' ).change( function() {
		if ( $(this)[0].checked ) {
			$( this ).parents( '.picu-option-set' ).find( '.js-collapsible' ).removeClass( 'is-collapsed' );
		}
		else {
			$( this ).parents( '.picu-option-set' ).find( '.js-collapsible' ).addClass( 'is-collapsed' );
		}
	});

	$( '#picu-selection-option' ).change( function() {
		if ( 'in the range of' == $( this ).val() ) {
			$( '.picu-range' ).show();
		}
		else {
			$( '.picu-range' ).hide();
		}
	});


	// Integrate clipboard.js
	if ( Clipboard.isSupported() ) {
		var clipboard = new Clipboard( '.picu-copy-to-clipboard' );

		clipboard.on( 'success', function( e ) {
			e.clearSelection();
			$( '.picu-copy-to-clipboard' ).addClass( 'picu-copied-success' );
		});
	}
	else {
		$( 'label[for="picu-copy-filenames"], #picu-copy-filenames' ).show();
		$( '.picu-copy-to-clipboard' ).hide();
	}


	// Save picu pro box visibility state
	$( '.picu-pro-meta-box-visibility' ).click( function() {

		var checked = true;
		if ( $( '#picu-pro-meta-box-visibility' )[0].checked ) {
			checked = false;
		}

		// Send ajax request
		$.post( picu_admin.ajaxurl, {
			action: 'picu_save_pro_box_state',
			security: picu_admin.ajax_nonce,
			picu_hide_pro_box: checked,

		}, function( response ) {
			// Ajax success
		}).fail( function() {
			// Ajax fail
		});
	});

	// Adjust status selection options in quick menu
	$( 'select[name="_status"] > [value="publish"]' ).remove();
	$( 'select[name="_status"] > [value="pending"]' ).remove();
	$( 'select[name="_status"]' ).append( '<option value="sent">' + picu_admin.sent_option_label + '</option><option value="approved">' + picu_admin.approved_option_label + '</option>' );


	// Move the skip link from footer to header
	var skipLink = $( '#wpfooter .picu-skip-to-delivery' );
	$( '.wrap .wp-heading-inline' ).after( skipLink );


	// Hide Skip to Delivery link if editor is dirty
	var skipLink = document.getElementsByClassName( 'picu-skip-to-delivery' );

	if ( skipLink.length > 0 ) {
		var targetNode = document.getElementById( 'post' );
		var dirtyObserver = new MutationObserver( function( mutations ) {
			mutations.forEach( function( mutation ) {
				if ( mutation.attributeName == 'class' ) {
					if ( mutation.target.classList.contains( 'dirty' ) ) {
						skipLink[0].style.display = 'none';
					}
				}
			});
		});

		dirtyObserver.observe( targetNode, {attributes: true} );
	}

})( jQuery );